#!/bin/bash
#############################################################################
#  Gradio un programa de Automatización de radio programado en bash         #
#			  Última actualización: 16-julio-2020   	    #
#############################################################################
#	     Projecto iniciado el 16 de junio de 2011	    		    #
#############################################################################
#############################################################################
#                                                                           #
# This program is free software; you can redistribute it and/or modify it   #
# under the terms of the GNU General Public License as published by the     #
# Free Software Foundation; either version 2 of the License or any later    #
# version.								    #
#									    #
# This program is distributed in the hope that it will useful, but WITHOUT  #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License     #
# for more details.							    #
#									    #
############################################################################# 
# autor: Charles Escobar
# sitio: http://www.gradio.net
# fecha: 07/10/2022
# ver: 5 mpv 
# Script para automatizar G-Radio
# G Radio bash module  -v 5.0 name: Indefinido
#sudo apt install jq
#sudo apt install socat
#sudo apt install pqiv
#sudo apt install wmctrl

echo "Cargando.." > $HOME/.gradio/data/tmp/avance
echo "Modo Automático" > $HOME/.gradio/data/tmp/currentcomercial.txt;

############# CONDICIONES INICIALES #########################################
device=`cat $HOME/.gradio/data/devmain`
echo 0 > $HOME/.gradio/data/tmp/eventosplay
echo 0 > $HOME/.gradio/data/tmp/loop
echo "0" > $HOME/.gradio/data/tmp/stopGR4
echo $$ > $HOME/.gradio/data/pid
echo "0" > $HOME/.gradio/data/tmp/pausa
echo 0 > $HOME/.gradio/data/tmp/nextpar
echo 0 > $HOME/.gradio/data/tmp/nextimpar
echo "auto" > $HOME/.gradio/data/tmp/modoprevio
if [[ ! -d $HOME/.gradio/data/tmp/intercarpetas ]]; then
	mkdir $HOME/.gradio/data/tmp/intercarpetas
fi
if [[ ! -p $HOME/.gradio/data/tmp/par.fifo ]]; then
	mkfifo $HOME/.gradio/data/tmp/par.fifo
fi
if [[ ! -p $HOME/.gradio/data/tmp/efecto.fifo ]]; then
	mkfifo $HOME/.gradio/data/tmp/efecto.fifo
fi
if [[ ! -p $HOME/.gradio/data/tmp/impar.fifo ]]; then
	mkfifo $HOME/.gradio/data/tmp/impar.fifo
fi
if [[ ! -p $HOME/.gradio/data/tmp/imparcom.fifo ]]; then
	mkfifo $HOME/.gradio/data/tmp/imparcom.fifo
fi
if [[ ! -p $HOME/.gradio/data/tmp/parcom.fifo ]]; then
	mkfifo $HOME/.gradio/data/tmp/parcom.fifo
fi
if [[ ! -f $HOME/.gradio/data/tmp/temacounter ]]; then
	echo 0 > $HOME/.gradio/data/tmp/temacounter
fi
if [[ ! -f $HOME/.gradio/data/entrepisador ]]; then
	echo 2 > $HOME/.gradio/data/entrepisador
fi

if [[ ! -f $HOME/.gradio/data/tmp/eventos-esperalist ]]; then
	touch $HOME/.gradio/data/tmp/eventos-esperalist
fi

if [[ ! -f $HOME/.mplayer/config  ]]; then
	mkdir $HOME/.mplayer 
	echo "# Write your default config options here!" > $HOME/.mplayer/config 
	echo "softvol=true" >> $HOME/.mplayer/config 
	echo "ao=pulse" >> $HOME/.mplayer/config 
else
	softvol=`grep "softvol=true" $HOME/.mplayer/config`
	aopulse=`grep "ao=pulse" $HOME/.mplayer/config`
	if [[ $softvol = "" ]];then
		echo "softvol=true" >> $HOME/.mplayer/config 
	fi
	if [[ $aopulse = "" ]];then
		echo "ao=pulse" >> $HOME/.mplayer/config 
	fi
fi
if [[ ! -f $HOME/.gradio/data/tmp/equalizer ]]; then echo 0:0:0:0:0:0:0:0:0:0 > $HOME/.gradio/data/tmp/equalizer;fi
equalizer=`cat $HOME/.gradio/data/tmp/equalizer`

daemon=`ps -x|grep -v grep|grep .gradio/bin/comercialdaemon.sh`
if [[ $daemon != "" ]];then
	killall -9 comercialdaemon.sh
fi
daemon=`ps -x|grep -v grep|grep .gradio/bin/comercialdaemon4.sh`
if [[ $daemon != "" ]];then
	killall -9 comercialdaemon4.sh
fi
daemon=`ps -x|grep -v grep|grep .gradio/bin/cargalista.sh`
if [[ $daemon != "" ]];then
	killall -9 cargalista.sh
fi
semiautomatico=`cat $HOME/.gradio/data/tmp/listavacia`
daemon=`ps -x|grep -v grep|grep .gradio/bin/cargalista4.sh`
if [[ $daemon != "" && $semiautomatico = 0 ]];then
	killall -9 cargalista4.sh
fi

mascara=`ps uax|grep GMain.gambas|grep -v grep`

#Vaciar eventos
cat /dev/null > $HOME/.gradio/data/tmp/eventoslist
cat /dev/null > $HOME/.gradio/data/tmp/eventoslistweb
cat /dev/null > $HOME/.gradio/data/tmp/eventoslistwebg3
sed -i "1d" $HOME/.gradio/data/tmp/eventoslist
sed -i "1d" $HOME/.gradio/data/tmp/eventoslistweb
sed -i "1d" $HOME/.gradio/data/tmp/eventoslistwebg3

semiautomatico=`cat $HOME/.gradio/data/tmp/listavacia`
y=`ps -e |grep cargalista4.sh`
if [[ $y = "" && $semiautomatico = 0 ]]; then
	$HOME/.gradio/bin/cargalista4.sh & 
fi

z=`ps -uax |grep comercialdaemon4.sh|grep -v grep`
if [ "$z" = "" ]; then 
	$HOME/.gradio/bin/comercialdaemon4.sh & 
fi
#sleep 1 #Tiempo para que el cargalista cargue el playlist
echo "Listo!" > $HOME/.gradio/data/tmp/avance
salir=0
saliolazo=0

####################################################
function tiempo() {
duracion=`mplayer -vo null -ao null -frames 0 -identify "$1" 2>&1 | grep ID_LENGTH|awk -F"=" '{print $2}'|awk -F "." '{print $1}'`
echo "00:00:$duracion" > $HOME/.gradio/data/tmp/duracion
segundos=$duracion
echo "segundos:" $segundos
return $segundos
}

function cleanms() {
	echo "" > $HOME/.gradio/data/tmp/mstatus
}

function f_temainc() {

	temacounter=$(( $temacounter + 1 ))
	echo $temacounter > $HOME/.gradio/data/tmp/temacounter			
	espar=$(( $temacounter % 2))
	$HOME/.gradio/bin/GR_ClientSocketPlayList.gambas &
	if [[ $espar == 0 ]]; then
		fifofile="$HOME/.gradio/data/tmp/par.fifo"
		porc="par"
	else
		fifofile="$HOME/.gradio/data/tmp/impar.fifo"
		porc="impar"
	fi
	echo "$fifofile" > $HOME/.gradio/data/tmp/fifofile
	volup=`cat  $HOME/.gradio/data/tmp/upvol`
	voldown=`cat  $HOME/.gradio/data/tmp/downvol`

}

function f_testfifo() {
	testfifo=`ps uax|grep $1|grep -v grep|awk '{ print $2 }'`
	#echo "testfifo: $testfifo"
}

function f_fadeout() {
	modo=`cat $HOME/.gradio/data/tmp/modo`
if [[ $modo = "1" ]]; then
	volup=`cat  $HOME/.gradio/data/tmp/upvol`
	voldown=`cat  $HOME/.gradio/data/tmp/downvol`

	echo "bajando volume a $1"
	f_testfifo $1
	proceso=`ps ax|grep "$1"|grep -v grep|awk -F" " '{ print $1 }'`
	down=$volup
	while [[ $down -ge 5  ]]; do
		if [[ $testfifo ]]; then echo "set_property volume $down" > $1;fi
		down=$(($down -2))
		sleep 0.07
	done
	up=$voldown
#	while [[ $up -le $volup  ]]; do
#		echo "set_property volume $up" > $fifofile
#		up=$(($up +2))
#		done
#	fi
	echo "quit" #> $fifofile &
	f_testfifo $1
	if [[ $testfifo ]]; then
		echo "quit" > $1 &
	fi
fi
	echo "fin fadeout"
}

function f_espera() {
	disparo=0
	fundidocom=`cat $HOME/.gradio/data/tmp/fundidocomerciales`
	mix=`cat $HOME/.gradio/data/mix.txt`
	if [[ $1 = "Comercial" ]]; then
	salto=`echo "$duracion-$disparo>$fundidocom"|bc`
	else
	salto=`echo "$duracion-$disparo>$mix"|bc`
	fi	
	f_testfifo $2
	echo "Inicial: Dur: $duracion Disp: $disparo Salto: $salto .gradio/data/tmp/mstatus$porc"
	nextfifo=`cat $HOME/.gradio/data/tmp/next$porc`	
		while [[ $salto = 1 && $testfifo && $nextfifo = 0 ]]; do
			f_testfifo $2			
			pausa=`cat $HOME/.gradio/data/tmp/pausa`
			if [[ $pausa = 0 ]];then
				if [[ $testfifo ]]; then echo "get_time_pos" > $2;fi	
			else
				echo "en pausa"
			fi
			sleep 1
			disparo=`cat $HOME/.gradio/data/tmp/mstatus$3|grep "ANS_TIME_POSITION"|tail -n1|awk -F "=" '{ print $2 }'`
			if [[ $1 = "Comercial" ]]; then
				salto=`echo "$duracion-$disparo>$fundidocom"|bc`
				$HOME/.gradio/bin/GR_ClientSocketCom.gambas &
			else
				salto=`echo "$duracion-$disparo>$mix"|bc`
			fi
			#echo "Lazo: : Dur: $duracion Disp: $disparo Salto: $salto $HOME/.gradio/data/tmp/mstatus$3"	
			nextfifo=`cat $HOME/.gradio/data/tmp/next$porc`					
		done
		echo "va a fadeout"
		f_fadeout $2 &
}
		
function f_inimain() {
	minini=`date  +%-M`
	hini=`date +%-H`
	hora=`date  +%-H` 
	dia=`date +%u`
	minuto=`date +%-M`
	previo="inicio"
	ranura=`echo "$hora-$(($hora+1)).mus"`
	echo 0 > $HOME/.gradio/data/tmp/repitiendo
	echo "Mensajes auxiliares GR" > $HOME/.gradio/data/tmp/currentcomercial.txt
	echo "Visor de Temas Musicales" > $HOME/.gradio/data/tmp/currentsong.txt
	caracteres=`wc -m $HOME/.gradio/data/parrilla/$dia/$ranura|cut -d " " -f 1`
	nlineas=`grep -c $ $HOME/.gradio/data/tmp/playlist4`
	hora1=`date  +%-H` 
}

function f_iniloop() {
				device=`cat $HOME/.gradio/data/devmain`				
				estadotv=`cat $HOME/.gradio/data/tmp/tvestado`
				desplazamiento=`cat $HOME/.gradio/data/tmp/tvdesplazamiento`
				teletexto=`cat $HOME/.gradio/data/tmp/teletexto`
				if [[ $estadotv = 1 ]]; then tvopcion="-fs -geometry $desplazamiento";else tvopcion="-novideo";fi
				srt=$HOME/.gradio/data/tmp/teletexto.srt
				color=`cat $HOME/.gradio/data/tmp/teletexto.color`
				if [[ $estadotv = 1 && $teletexto = 1 ]]; then srtopcion="-utf8 -sub $srt $color ";else srtopcion="";fi
				randomfile=`sed -n 1p $HOME/.gradio/data/tmp/playlist4|sed '$s/\(^[^\t]*\).*$/\1/'`
				url_str=`sed -n 1p $HOME/.gradio/data/tmp/playlist4`
				sed -i "1d" $HOME/.gradio/data/tmp/playlist4  
				nombrebase=`echo "$randomfile" |awk -F/ '{print $NF}'`
				musini=`date +%s`	
				musinicio=`date +%H:%M:%S`
}

function f_hora() {
	twitter=`cat $HOME/.gradio/data/tmp/twidge`
	mix=`cat $HOME/.gradio/data/mix.txt`
	nombrebase="Hora"
	echo "Hora" > $HOME/.gradio/data/tmp/currentsong.txt 
	echo "0" > $HOME/.gradio/data/tmp/porciento
	if [[ $twitter = 1 ]]; then 
		echo "Ahora emitiendo la hora"|twidge update & 
	fi
	echo "Hora" > $HOME/CurrentSong.txt
	cdown=`ps -x|grep -v grep|grep .gradio/bin/countdown.sh`
	if [[ $cdown != "" ]]; then
		killall -9 countdown.sh
	fi
	echo "Hora" > $HOME/.gradio/data/tmp/avance
	sleep 0.1
	if [[ $1 = "parrilla" ]];then 
		$HOME/.gradio/bin/GR_ClientSocketPlayList.gambas &
	fi
	if [[ $1 = "comercial" ]];then 
		$HOME/.gradio/bin/GR_ClientSocketCom.gambas &
	fi
		desiguiente=`cat $HOME/.gradio/data/tmp/desiguiente`
		if [[ $desiguiente = 0 && $mix > 1 ]]; then
			sleep $(($mix-2)) 
		fi
	xterm -iconic  -fg Green -bg DarkBlue -title "hora" -geometry 40x1-0+0  -e $HOME/.gradio/data/panel/hora.sh
	previo="$randomfile"
	desiguiente=0
	modo=`cat $HOME/.gradio/data/tmp/modo`
	if [[ $modo = 0 ]]; then
		sleep $mix
		$HOME/.gradio/bin/detenermanual4.sh Funciones-6_f_hora
	fi
}

function f_plugline() {
	echo "Reproduciendo PlugLineInGRadio" > $HOME/.gradio/data/tmp/currentsong.txt 				
	pactl load-module module-loopback latency_msec=5
	echo "00:00:$PlugLineInGRadio"  > $HOME/.gradio/data/tmp/duracion
	$HOME/.gradio/bin/countdown.sh &
	sleep $PlugLineInGRadio
	pactl unload-module module-loopback
}

function f_streamingold() {

		twitter=`cat $HOME/.gradio/data/tmp/twidge`
		mix=`cat $HOME/.gradio/data/mix.txt`
		nombrebase="$url_streaming"
		duracion_url=`echo $url_str|awk -F " " '{print $2}'`
		streaming_url=`echo $url_str|awk -F " " '{print $1}'`
		echo "duracion_url: $duracion_url, streaming_url: $streaming_url"
		echo "$url_streaming" > $HOME/.gradio/data/tmp/currentsong.txt 
		echo "$url_streaming" > $HOME/CurrentSong.txt
		if [[ $twitter = 1 ]]; then 
			echo "Ahora emitiendo $url_streaming"|twidge update & 
		fi
		echo "$url_streaming" > $HOME/CurrentSong.txt
		cdown=`ps -x|grep -v grep|grep .gradio/bin/countdown.sh`
		if [[ $cdown != "" ]]; then
			killall -9 countdown.sh
		fi
		echo "00:00:$duracion_url" > $HOME/.gradio/data/tmp/duracion
		sleep 0.1
		$HOME/.gradio/bin/countdown.sh &
		$HOME/.gradio/bin/GR_ClientSocketPlayList.gambas &
		desiguiente=`cat $HOME/.gradio/data/tmp/desiguiente`
		if [[ $desiguiente = 0 && $mix > 1 ]]; then
			sleep $(($mix-2)) 
		fi
		xterm -iconic  -fg Green -bg DarkBlue -title "Cadena de Streaming" -geometry 40x1-0+0  -e timeout $duracion_url mplayer $device -slave -input file="$fifofile" $streaming_url > $HOME/.gradio/data/tmp/mstatus$porc
		cleanms
		.  $HOME/.gradio/bin/panico.sh &
		previo="$randomfile"
		desiguiente=0
		modo=`cat $HOME/.gradio/data/tmp/modo`
		if [[ $modo = 0 ]]; then
			sleep $mix
			$HOME/.gradio/bin/detenermanual4.sh Funciones-6_f_streamingold
		fi
}



function f_comercial() {

	modo=`cat $HOME/.gradio/data/tmp/modo`
	if [[ $modo = 0 ]]; then
		sleep $mix
		$HOME/.gradio/bin/detenermanual4.sh Funciones-6_f_comercial
	fi	
	if [[ $1 = "Evento" ]]; then
		cnelineas=`grep -c $ $HOME/.gradio/data/tmp/eventoslist`
		f_ruta="$HOME/.gradio/data/tmp/eventoslist"
	fi
	if [[ $1 = "Comercial" ]]; then
		iniespaciop=`cat $HOME/.gradio/data/tmp/espacio`
		cnelineas=`grep -c $ $HOME/.gradio/data/tmp/comercialeslist4`	
		f_ruta="$HOME/.gradio/data/tmp/comercialeslist4"	
	fi
	
	if [[ $1 = "Evento-espera" ]]; then
		cnelineas=`grep -c $ $HOME/.gradio/data/tmp/eventos-esperalist`
		f_ruta="$HOME/.gradio/data/tmp/eventos-esperalist"
	fi	

	if [ -s $f_ruta ]; then
		if [[ $1 = "Evento" ]]; then
			echo 1 > $HOME/.gradio/data/tmp/eventosplay
		fi
		minini=`date  +%-M`
		hini=`date +%-H`
		cnlinea=1 
		
		desiguiente=`cat $HOME/.gradio/data/tmp/desiguiente`
		if [[ $desiguiente = 0 && $mix > 0 ]]; then
			sleep $(($mix-1))
		fi
		
		twitter=`cat $HOME/.gradio/data/tmp/twidge`
		if [[ $twitter = 1 ]]; then 
			echo "Ahora emitiendo $1"|twidge update &
			xterm -iconic  -fg Green -bg DarkBlue -title "Clima" -geometry 40x1-0+0  -e $HOME/.gradio/bin/tiempo-clima.sh &
		fi
		if [[ $1 = "Comercial" ]]; then
			if [[ $iniespaciop = 1 ]]; then
				$HOME/.gradio/data/panel/playinicioespacio.sh 
				sleep 1
				iniespaciop=3
			fi
		fi
		
	while [[ $cnelineas -ge 1 ]]; do
		f_temainc
		if [[ $1 = "Evento" ]]; then
			sed -i "1d" $HOME/.gradio/data/tmp/eventoslistwebg3
		fi
		if [[ $1 = "Evento-espera" ]]; then
			sed -i "1d" $HOME/.gradio/data/tmp/eventos-esperalistwebg3
		fi
		echo "0" > $HOME/.gradio/data/tmp/porciento
		comercial=`head -n1 $f_ruta|sed '$s/\(^[^\t]*\).*$/\1/'|sed '$s/\(^[^\t]*\).*$/\1/'|sed 's/[[:blank:]]*$//'` #Considera el tiempo`
		PlugLineInGRadio=`echo $comercial|awk -F"|" '{ print $1 }'|grep PlugLineInGradio|awk -F" " '{ print $NF }'`					
		echo "comercial $1:" $comercial
		nombrebase=`echo "$comercial" |awk -F"/" '{print $NF}'`  #$comercial  
		comini=`date +%s`
		cominicio=`date +%H:%M:%S`
		echo "$1: ${nombrebase%.*}" > $HOME/.gradio/data/tmp/currentsong.txt;
		echo "$1: ${nombrebase%.*}" > $HOME/CurrentSong.txt
		echo "$1: ${nombrebase%.*}" > $HOME/.gradio/data/tmp/currentcomercial.txt;

		sleep 0.2
		cdown=`ps -x|grep -v grep|grep .gradio/bin/countdown.sh`
		if [[ $cdown != "" ]]; then
		killall -9 countdown.sh
		fi
		lista=`echo $comercial|awk -F"|" '{ print $1 }'|awk -F"." '{ print $NF }'`
		#echo "lista: "$lista
	############## HORA
		if [[ $comercial = "Hora" && $previo != "$comercial" ]]; then	## Es hora?
			sed -i "1d" "$f_ruta"
			$HOME/.gradio/bin/GR_ClientSocketCom.gambas &			
			f_hora comercial			
	############## PlugLineInGRadio
		elif [[ $PlugLineInGRadio -gt 0 ]]; then					
			sed -i "1d" "$f_ruta"
			$HOME/.gradio/bin/GR_ClientSocketCom.gambas &
			f_plugline					
		elif [[ $lista = "gradio" && $previo != "$comercial" ]]; then
			cp "$comercial" $HOME/.gradio/data/tmp/playlist4
			sed -i "1d" "$f_ruta"
			$HOME/.gradio/bin/GR_ClientSocketPlayList.gambas &
		else ##No es hora ni lista
			internet=`echo "$comercial"|grep "http://"`
			internets=`echo "$comercial"|grep "https://"`
			echo "$comercial" > $HOME/.gradio/data/tmp/tmpweb
			ejecutar=`echo $comercial|grep 123456789098765432100`
			comando=`echo $comercial|awk -F"&&" '{print $2}'`
			if [[ $internet != "" || $internets != "" ]]; then				
				f_streaming $1 
				sed -i "1d" "$f_ruta"
			else		
				if [[ $ejecutar = "" ]]; then
					tiempo "$comercial"
					cdown=`ps -x|grep -v grep|grep .gradio/bin/countdown.sh`
					if [[ $cdown != "" ]]; then
						killall -9 countdown.sh
					fi
					$HOME/.gradio/bin/countdown.sh &
					if [[ $1 = "Comercial" ]]; then
						srtopcion=""	
					fi
					mplayer $device $tvopcion -vf bmovl=0:0:$HOME/.gradio/data/tmp/logo.fifo  $srtopcion -volume $volup -quiet -slave -input file=$fifofile  "$comercial" > $HOME/.gradio/data/tmp/mstatus$porc &
					echo "borra linea"
					sed -i "1d" "$f_ruta"
					$HOME/.gradio/bin/GR_ClientSocketCom.gambas &
					cleanms
					.  $HOME/.gradio/bin/panico.sh &					
					#cnlineas=`grep -c $ $f_ruta`
					echo 0 > $HOME/.gradio/data/tmp/next$porc
					f_espera Comercial $fifofile $porc
					
					previo="$comercial"
				else
					source $comando
				fi
				
			fi
			cnelineas=`grep -c $ $f_ruta`
			comfin=`date +%s`
			duracion=$(( $comfin - $comini ))
			if [ -s $HOME/.gradio/data/reporte/comercial-`date +%Y-%d-%m` ]; then
				touch $HOME/.gradio/data/reporte/comercial-`date +%Y-%d-%m`
			fi
			echo `date +%Y-%m-%d`,$cominicio,`echo "$comercial"|sed s/","/"_"/g`,$duracion,segundos,eventos >> $HOME/.gradio/data/reporte/comercial-`date +%Y-%d-%m`.txt #Reporte comerciales
		fi  #No es Hora
		
		$HOME/.gradio/bin/GR_ClientSocketCom.gambas
		done
	fi

	if [[ $1 = "Comercial" ]]; then
		if [[ $iniespaciop = 3 ]]; then
			sleep 1
			$HOME/.gradio/data/panel/playfinespacio.sh #xterm -iconic  -fg Green -bg Red -title "$nombrebase"  -geometry 40x1-0+0 -e 
		fi
		espera=`cat $HOME/.gradio/data/tmp/stopcomercial`
		while [[ $espera = 1 ]]; do
			echo "GR4: \"Detenido al finalizar el comercial\" Play para continuar" > $HOME/.gradio/data/tmp/currentsong.txt
			echo "GR4: \"Detenido al finalizar el comercial\" Play para continuar" > $HOME/.gradio/data/tmp/currentcomercial.txt
			sleep 1
			espera=`cat $HOME/.gradio/data/tmp/stopcomercial`
		done
	fi
	
	echo "Mensajes auxiliares GR" > $HOME/.gradio/data/tmp/currentcomercial.txt;
	
	if [[ $1 = "Evento" ]]; then
		echo 0 > $HOME/.gradio/data/tmp/eventosplay
	fi
}

f_mpvdev() {
	mplmainum=`cat .gradio/data/devmain|awk -F":" '{print $3}'`
	#mplmaindev=$(($mplmaindev+1))
	mplmaindev=`pacmd list-sinks|grep -E 'device.desc|index'|sed s/'device.description = '//g|sed s/'\t'//g|sed s/'    index: '//g|sed s/'*'//g|sed s/'   index: '//g|grep $mplmainum -A1|tail -n1|sed s/\"//g`
	mpvmaindev=`mpv --audio-device=help|grep pulse|grep -i "$mplmaindev"|awk '{ print $1 }'|sed s/"'"//g`   
	#`mpv --audio-device=help|grep pulse|awk -F" " '{ print $1 }'|sed s/"'"//g|sed  -n $mplmaindev"p"`
}


function f_streaming() {
	mix=`cat $HOME/.gradio/data/mix.txt`
	if [[ $1 = "Evento" || $1 = "Evento-espera" ]]; then
		randomfile=`echo "$comercial"|awk '{print $NF}'`
		duracion_url=`echo "$comercial"|awk '{ print $(NF-1) }'`

	else 
		duracion_url=`echo $url_str|awk -F " " '{print $2}'`
	fi
	#echo "duracion_url: $duracion_url, streaming_url: $streaming_url"
	twitter "$randomfile" &
	cdown=`ps -x|grep -v grep|grep .gradio/bin/countdown.sh`
	if [[ $cdown != "" ]]; then killall -9 countdown.sh;fi
	echo "00:00:$duracion_url" > $HOME/.gradio/data/tmp/duracion
	sleep 0.1
	$HOME/.gradio/bin/countdown.sh STREAM &
	$HOME/.gradio/bin/GR_ClientSocketPlayList.gambas &
	echo "1" > $HOME/.gradio/data/tmp/url
	desiguiente=`cat $HOME/.gradio/data/tmp/desiguiente`
	if [[ $desiguiente = 0 && $mix > 1 ]];then sleep $(($mix-2));fi
	echo "URL:$randomfile" > $HOME/CurrentSong.txt
	echo "URL:$randomfile" > $HOME/.gradio/data/tmp/currentsong.txt
	f_mpvdev
	timeout $duracion_url mpv --audio-device=$mpvmaindev --volume=$volup --quiet --audio-pitch-correction=yes $randomfile #> $HOME/CurrentSong.txt
	previo="$randomfile"
	desiguiente=0
	echo "0" > $HOME/.gradio/data/tmp/url
	modo=`cat $HOME/.gradio/data/tmp/modo`
}

function audiotype() {
			title=`mediainfo --Inform='General;%Title%'  "$randomfile"`
			performer=`mediainfo --Inform='General;%Performer%'  "$randomfile"`
			genre=`mediainfo --Inform='General;%Genre%'  "$randomfile"`
			if [[ -s $HOME/.gradio/data/tmp/nacionalcarpetas ]];then
				if [[ `echo $randomfile |grep -f $HOME/.gradio/data/tmp/nacionalcarpetas` ]]; then type=nacional;else type=extranjera;fi
			else
				type="parrilla"
			fi
			if [[ `echo $randomfile |grep -f $HOME/.gradio/data/tmp/promoscarpetas` ]]; then type=promos;fi
			if [[ $randomfile = "Hora" ]]; then type=hora;fi
			if [[ `echo $randomfile |grep -f $HOME/.gradio/data/tmp/intercarpetas` ]]; then type=intercultural;fi
}

function urltype() {
			title="$randomfile"
			performer="$1"
			genre="$1"
			type="$1"
}


