#!/bin/bash

#############################################################################
#  Gradio un programa de Automatización de radio programado en bash  #
#	  Última actualización: 28-Jul-2011    #
#############################################################################
#	     Projecto iniciado el 16 de junio de 2011	        #
#############################################################################
#############################################################################
#                                                                           #
# This program is free software; you can redistribute it and/or modify it   #
# under the terms of the GNU General Public License as published by the     #
# Free Software Foundation; either version 2 of the License or any later    #
# version.    #
#	    #
# This program is distributed in the hope that it will useful, but WITHOUT  #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License     #
# for more details.	    #
#	    #
############################################################################# 

DIR_GR="$HOME/.gradio"

#Función backupgr() desarrollada por Javier Obregón

backupgr() {
	## Creación del archivo $DIR_GR/respaldos y reubicación de archivos de respaldo previos
	if [[ ! -d $DIR_GR/respaldos ]]; then
		mkdir $DIR_GR/respaldos
		sleep 0.5 #En los discos sólidos hay problemas si no espera?
		mkdir $DIR_GR/respaldos/data
		mkdir $DIR_GR/respaldos/bin
		mv $DIR_GR/bin-respaldo-* $DIR_GR/respaldos/bin/
		mv $DIR_GR/data/comerciales-respaldo-* $DIR_GR/respaldos/data/
		mv $DIR_GR/data/eventos-respaldo-* $DIR_GR/respaldos/data/
		mv $DIR_GR/data/panel-respaldo-* $DIR_GR/respaldos/data/
		mv $DIR_GR/data/eventos-espera-respaldo-* $DIR_GR/respaldos/data/
		mv $DIR_GR/data/parrilla-respaldo-* $DIR_GR/respaldos/data/
		mv $DIR_GR/data/reporte-respaldo-* $DIR_GR/respaldos/data/
		mv $DIR_GR/data/tmp/nacionalcarpetas-respaldo-* $DIR_GR/respaldos/data/tmp/nacionalcarpetas
		mv $DIR_GR/data/tmp/intercarpetas-respaldo-* $DIR_GR/respaldos/data/tmp/intercarpetas
		
		
	fi
	## Respaldo de los archivos en $DIR_GR/bin
	cp -R $DIR_GR/bin $DIR_GR/respaldos/bin/bin-respaldo-"`date +%d-%m-%Y-%H:%M:%S`"
	## Respaldo de comerciales eventos panel en $DIR_GR/data/ 
	cp -R $DIR_GR/data/comerciales $DIR_GR/respaldos/data/comerciales-respaldo-"`date +%d-%m-%Y-%H:%M:%S`"
	cp -R $DIR_GR/data/eventos $DIR_GR/respaldos/data/eventos-respaldo-"`date +%d-%m-%Y-%H:%M:%S`"
	cp -R $DIR_GR/data/panel $DIR_GR/respaldos/data/panel-respaldo-"`date +%d-%m-%Y-%H:%M:%S`"
	## Agregado en 2.2.2 - Renegado
	cp -R $DIR_GR/data/eventos-espera $DIR_GR/respaldos/data/eventos-espera-respaldo-"`date +%d-%m-%Y-%H:%M:%S`"
	cp -R $DIR_GR/data/parrilla $DIR_GR/respaldos/data/parrilla-respaldo-"`date +%d-%m-%Y-%H:%M:%S`"
	cp -R $DIR_GR/data/reporte $DIR_GR/respaldos/data/reporte-respaldo-"`date +%d-%m-%Y-%H:%M:%S`"
	cp $DIR_GR/data/tmp/nacionalcarpetas $DIR_GR/respaldos/data/tmp/nacionalcarpetas-respaldo-"`date +%d-%m-%Y-%H:%M:%S`"
	cp $DIR_GR/data/tmp/intercarpetas $DIR_GR/respaldos/data/tmp/intercarpetas-respaldo-"`date +%d-%m-%Y-%H:%M:%S`"
}

zenity --warning --width=450 --text  "Con esta herramienta va a restaurar la siguiente configuración de G-Radio: \n *La Parrilla Musical \n *El pautaje de Comerciales \n *El pautaje de Eventos \n *El pautaje de Eventos en Espera, \n *Ruta carpetas nacionales, \n *Ruta carpetas interculturales y; \n *Configuración de Efectos \n ADVERTENCIA: ESTO BORRARÁ SU CONFIGURACIÓN ACTUAL"

FILE=`zenity --file-selection --title="Seleccione el archivo G Radio a restaurar"`
case $? in
         0)
                echo "\"$FILE\" seleccionado.";;
         1)
                echo "No ha seleccionado un archivo.";;
        -1)
                echo "Ha currido un error.";;
esac

validar=`echo $FILE|grep "gradio-data-"|grep ".tar.gz"`
echo "validar: " $validar

if [[ $validar != "" ]]; then
	if [[ -f $HOME/.restore-gr ]]; then
		rm -Rf $HOME/.restore-gr
	else
		mkdir $HOME/.restore-gr
	fi
	tar -zxvf $FILE -C $HOME/.restore-gr
	
	backupgr
	
	rm -Rf $DIR_GR/data/comerciales
	rm -Rf $DIR_GR/data/eventos
	rm -Rf $DIR_GR/data/panel
	rm -Rf $DIR_GR/data/eventos-espera
	rm -Rf $DIR_GR/data/parrilla
	rm -Rf $DIR_GR/data/reporte
	rm -Rf $DIR_GR/data/tmp/nacionalcarpetas
	rm -Rf $DIR_GR/data/tmp/intercarpetas

	mv $HOME/.restore-gr/gradio-data/data/comerciales $DIR_GR/data/
	mv $HOME/.restore-gr/gradio-data/data/eventos $DIR_GR/data/
	mv $HOME/.restore-gr/gradio-data/data/panel $DIR_GR/data/
	mv $HOME/.restore-gr/gradio-data/data/eventos-espera $DIR_GR/data/
	mv $HOME/.restore-gr/gradio-data/data/parrilla $DIR_GR/data/
	mv $HOME/.restore-gr/gradio-data/data/reporte $DIR_GR/data/
	mv $HOME/.restore-gr/gradio-data/data/tmp/nacionalcarpetas $DIR_GR/data/tmp/nacionalcarpetas
	mv $HOME/.restore-gr/gradio-data/data/tmp/intercarpetas $DIR_GR/data/tmp/intercarpetas
	rm -Rf $HOME/.restore-gr	
fi

exit 0



