#!/bin/bash

#############################################################################
#  Gradio un programa de Automatización de radio programado en bash  #
#			  Última actualización: 18-Enero-2011		    #
#############################################################################
#	     Projecto iniciado el 16 de junio de 2011	    		    #
#############################################################################
#############################################################################
#                                                                           #
# This program is free software; you can redistribute it and/or modify it   #
# under the terms of the GNU General Public License as published by the     #
# Free Software Foundation; either version 2 of the License or any later    #
# version.								    #
#									    #
# This program is distributed in the hope that it will useful, but WITHOUT  #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License     #
# for more details.							    #
#									    #
############################################################################# 
# autor: Charles Escobar
# sitio: http://www.gradio.net
# fecha: 02/12/2024
# ver: 1.0 RC
# Script para calcular la tabla estadística de temas y tiempos de artistas nacionales, globales e interculturlidad


function reporte() {

	usuario=`whoami`
	final=`date +%Y%m%d`
	hoy=$1"-"$2"-"$3
	echo $hoy

############ GLOBAL
acumuladoglobal=`cat $HOME/.gradio/data/reporte/GR6-parrilla*|grep $hoy|awk -F"," '{a+=$4}END{print int(a/3600)":"int(60*(a/3600-int(a/3600)))":"60*(60*(a/3600-int(a/3600))-int(60*(a/3600-int(a/3600))))}'`
dimarrglobal=`cat $HOME/.gradio/data/reporte/GR6-parrilla*|grep $hoy|wc -l`
############ INTERCULTURAL
if [[ -f $HOME/.gradio/data/tmp/intercarpetas ]]; then
acumuladoint=`cat $HOME/.gradio/data/reporte/GR6-parrilla*|grep -f $HOME/.gradio/data/tmp/intercarpetas|grep $hoy|awk -F"," '{a+=$4}END{print int(a/3600)":"int(60*(a/3600-int(a/3600)))":"60*(60*(a/3600-int(a/3600))-int(60*(a/3600-int(a/3600))))}'`
dimarrint=`cat $HOME/.gradio/data/reporte/GR6-parrilla*|grep -f $HOME/.gradio/data/tmp/intercarpetas|grep $hoy|wc -l`
fi

########### ARTISTA NACIONAL
if [[ -f $HOME/.gradio/data/tmp/nacionalcarpetas ]]; then
acumuladonac=`cat $HOME/.gradio/data/reporte/GR6-parrilla*|grep -f $HOME/.gradio/data/tmp/nacionalcarpetas|grep $hoy|awk -F"," '{a+=$4}END{print int(a/3600)":"int(60*(a/3600-int(a/3600)))":"60*(60*(a/3600-int(a/3600))-int(60*(a/3600-int(a/3600))))}'`
dimarrnacglobal=`cat $HOME/.gradio/data/reporte/GR6-parrilla*|grep -f $HOME/.gradio/data/tmp/nacionalcarpetas|grep $hoy|wc -l`
fi

datoprevio=`grep $hoy $reporte`

if [ "$datoprevio" = "" ]; then
	fechareporte="$1-$2-$3"
	echo "$fechareporte,$dimarrglobal,$acumuladoglobal,$dimarrnacglobal,$acumuladonac,$dimarrint,$acumuladoint" >> $reporte
fi

}

reporte="$HOME/.gradio/data/reportes/statistics-gradio6.txt"
if [ -f "$reporte" ]; then
	existe=1
	inicio=`tail -n 1 $reporte|awk -F"," '{ print $1}'` 
else
	touch "$reporte"
	inicio=$(ls $HOME/.gradio/data/reporte|grep "\-parrilla\-"|awk -F"-" '{print $3"-"$4"-"$5}'|sed s/"\.txt"//g|head -n1)
fi
hoydia=`date +%Y-%m-%d`
hoydiac=`echo $hoydia|sed s/"-"//g`
sed -i '$ d' $reporte

inicioc=`echo $inicio|sed s/"-"//g`
corriendo=`ps uax |grep tiempo-stats.sh|grep -v grep|head -n 1|wc -l`
if [[ $corriendo -lt 2 ]]; then
if [[ $(echo $inicioc|tr -dc '0-9'"\n") != "" ]]; then
	while [ $inicioc -le $hoydiac  ]; do
		anio=`echo $inicio|awk -F"-" '{ print $1 }'`
		dia=`echo $inicio|awk -F"-" '{ print $3 }'`
		mes=`echo $inicio|awk -F"-" '{ print $2 }'`
		reporte $anio $mes $dia
		inicio=`date -d "$inicio + day" +"%Y-%m-%d"`
		inicioc=`echo $inicio|sed s/"-"//g`
	done
else
		echo "está ejecutandose time-stats"
fi
fi
exit 0
